"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const helper_plugin_utils_1 = require("@babel/helper-plugin-utils");
const build_store_1 = __importDefault(require("@ray-core/build-store"));
const shared_1 = require("@ray-core/shared");
const lifecycleEvents = ['onShareAppMessage', 'onShareTimeline'];
exports.default = (options) => {
    let skip = false;
    return (0, helper_plugin_utils_1.declare)(() => {
        return {
            pre(state) {
                const importer = (0, shared_1.slash)(state.opts.filename);
                // TODO: app 的依赖也要收集
                skip = !options.test(importer);
                if (skip) {
                    return;
                }
                build_store_1.default.appEvents.delete(importer);
            },
            visitor: {
                // 解析 class properties 编译后的代码
                StringLiteral: (path, state) => {
                    var _a, _b;
                    if (skip) {
                        return;
                    }
                    const importer = (0, shared_1.slash)(state.file.opts.filename);
                    const { node } = path;
                    // 只要生命周期 Literal 存在就标记为用到了生命周期
                    if (!lifecycleEvents.includes(node.value)) {
                        return;
                    }
                    build_store_1.default.appEvents.set(importer, (_b = (_a = build_store_1.default.appEvents.get(importer)) === null || _a === void 0 ? void 0 : _a.add(node.value)) !== null && _b !== void 0 ? _b : new Set([node.value]));
                },
                Identifier: (path, state) => {
                    var _a, _b;
                    if (skip) {
                        return;
                    }
                    const importer = (0, shared_1.slash)(state.file.opts.filename);
                    const { node } = path;
                    // 只要生命周期 Identifer 存在就标记为用到了生命周期
                    if (!lifecycleEvents.includes(node.name)) {
                        return;
                    }
                    build_store_1.default.appEvents.set(importer, (_b = (_a = build_store_1.default.appEvents.get(importer)) === null || _a === void 0 ? void 0 : _a.add(node.name)) !== null && _b !== void 0 ? _b : new Set([node.name]));
                },
            },
        };
    });
};
